#pragma once

#include "BaseConsole.h"

namespace ehs
{
	class Console : public BaseConsole
	{
	private:
		static int hdlOut;
		static int hdlIn;

	public:
		static void Attach();

		static void Free();

		static void Write_32(const Str_32& str, bool newLine = true);

		static void Write_16(const Str_16& str, bool newLine = true);

		static void Write_8(const Str_8& str, bool newLine = true);

		static Str_32 Read_32(UInt_64 bufferSize = 1024);

		static Str_16 Read_16(UInt_64 bufferSize = 1024);

		static Str_8 Read_8(UInt_64 bufferSize = 1024);

		static void Clear();

		static void SetTitle_32(const Str_32& title);

		static void SetTitle_16(const Str_16& title);

		static void SetTitle_8(const Str_8& title);

		static Str_32 GetTitle_32();

		static Str_16 GetTitle_16();

		static Str_8 GetTitle_8();

		static Vector<Str_32> GetArgs_32(UInt_64 bufferSize = 1024);

		static Vector<Str_16> GetArgs_16(UInt_64 bufferSize = 1024);

		static Vector<Str_8> GetArgs_8(UInt_64 bufferSize = 1024);
	};
}