#include "ehs/system/Thread_W32.h"

namespace ehs
{
	Thread::~Thread()
	{

	}

	Thread::Thread()
	{

	}

	Thread::Thread(UInt_64 stackSize, void* args, UInt_32 (* func)(void*))
	{
		hdl = CreateThread(nullptr, stackSize, (LPTHREAD_START_ROUTINE)func, args, 0, (DWORD*)&id);
		if (!hdl)
			EHS_LOG_INT("Error", 0, "Failed to start thread with error #" + Str_8::FromNum(GetLastError()) + ".");
	}

	Thread::Thread(Thread&& thread) noexcept
	{

	}

	Thread::Thread(const Thread& thread)
	{

	}

	Thread& Thread::operator=(Thread&& thread) noexcept
	{
		return <#initializer#>;
	}

	Thread& Thread::operator=(const Thread& thread)
	{
		return <#initializer#>;
	}

	void Thread::Detach()
	{
		BaseThread::Detach();

		if (!CloseHandle(hdl))
		{
			EHS_LOG_INT("Error", 0, "Failed to detach thread with error #" + Str_8::FromNum(GetLastError()) + ".");
			return;
		}
	}

	void Thread::Join()
	{
		unsigned int r = WaitForSingleObject(hdl, timeout);
		if (r == WAIT_ABANDONED)
		{
			EHS_LOG_INT("Error", 0, "Abandoned wait because a mutex was not released.");
			return;
		}
		else if (r == WAIT_TIMEOUT)
		{
			return;
		}
		else if (r == WAIT_FAILED)
		{
			EHS_LOG_INT("Error", 1, "Failed to wait for thread with error #" + Str_8::FromNum(GetLastError()) + ".");
			return;
		}

		mainTaskIndex = 0;
	}

	UInt_32 Thread::GetCurrentId()
	{
		return GetCurrentThreadId();
	}

	bool Thread::IsValid() const
	{
		return BaseThread::IsValid();
	}

	void Thread::HardSleep(UInt_32 milliseconds)
	{
		Sleep(milliseconds);
	}
}